-- examples for graded modal logic. To run these examples, 
-- load the file gen.hs and try both provable and sat(isfiable)
-- on the formulas defined here.
-- Or simply append this file to gen.hs.

gdiam :: Int -> L G -> L G; gdiam k x = box (G k) x
gbox :: Int -> L G -> L G; gbox k x = neg (gdiam k (neg x))
gexcl :: Int -> L G -> L G;
gexcl 0 x = neg $ gdiam 0  x
gexcl k x = (gdiam (k - 1) x) /\ (neg (gdiam k x))

-- provable
psi :: L G; psi = gbox 0 T 
rho :: L G; rho = (gdiam 4 x) --> (gdiam 3 x)
gamma :: Int -> L G; gamma n = gbox 0 (x --> y) --> (gdiam n x -->
gdiam n y)
sigma :: Int -> Int -> L G;
sigma n1 n2= (gexcl 0 (x/\y))-->(((gexcl n1 x)/\(gexcl n2 y))-->(gexcl (n1 + n2) (x \/ y)))
delta :: L G; delta = (gdiam (3 + 5) (y) --> (gdiam 3 x) \/ (gdiam 5 y) )
eta :: L G; eta = neg $ (gdiam 2 x) /\ (gbox 1 (neg y)) /\ (gbox 1 (y))
beta :: L G; beta = ((neg x) /\ (gexcl 2 T) /\ (gexcl 2 x)) --> (gbox 0 x)

